fn main() {
    let input = include_str!("../../input.txt");
    let mut result = 0;

    for line in input.lines() {
        let parts: Vec<&str> = line.split(": ").collect();

        let mut min_red = 0;
        let mut min_green = 0;
        let mut min_blue = 0;

        for draw in parts.last().unwrap().split(&[',', ';'][..]) {
            let segments: Vec<&str> = draw.trim().split(" ").collect();

            let count: i32 = segments.first().unwrap().parse().unwrap();
            let min = match *segments.last().unwrap() {
                "red" => &mut min_red,
                "green" => &mut min_green,
                "blue" => &mut min_blue,
                _ => panic!(),
            };
            
            if count >= *min {
                *min = count;
            }
        }

        result += min_red * min_green * min_blue;
    }

    println!("Result: {}", result);
}
