fn main() {
    let input = include_str!("../../input.txt").trim_end();
    let mut extra_cards: Vec<i32> = Vec::new();
    let mut result = 0;
    let mut i = 0;

    for _ in input.lines() {
        extra_cards.push(0);
    }

    for line in input.lines() {
        let mut winning: Vec<i32> = Vec::new();
        let mut matches: i32 = 0;

        let multiplier = extra_cards[i] + 1;

        let parts: Vec<&str> = line
            .split(": ")
            .last()
            .unwrap()
            .split("|")
            .collect();
            
        for num in parts.first().unwrap().split(" ") {
            if num.is_empty() { continue; }
            winning.push(num.parse::<i32>().unwrap());
        }

        for num in parts.last().unwrap().split(" ") {
            if num.is_empty() { continue; }
            if winning.contains(&num.parse::<i32>().unwrap()) {
                matches += 1;
            }
        }

        for j in 1..=matches {
            if (i + j as usize) < extra_cards.len() {
                extra_cards[i + j as usize] += multiplier;
            }
        }

        result += multiplier;
        i += 1;
    }

    println!("Result: {}", result);
}
