fn main() {
    let input = include_str!("../../input.txt").trim_end().lines().collect::<Vec<&str>>();
    let mut times = input.first().unwrap().split(" ").filter(|item| item != &"").collect::<Vec<&str>>();
    let mut distances = input.last().unwrap().split(" ").filter(|item| item != &"").collect::<Vec<&str>>();
    let mut result = 1;

    times.remove(0);
    distances.remove(0);

    for index in 0..times.len() {
        let time = times[index].parse::<i32>().unwrap();
        let distance = distances[index].parse::<i32>().unwrap();
        let mut wins = 0;

        for i in 0..=time {
            if i * (time - i) > distance {
                wins += 1;
            }
        }

        result *= wins;
    }

    println!("Result: {result}");
}
