fn main() {
    let input = include_str!("../../input.txt");
    let mut result: i32 = 0;

    for line in input.lines() {
        let mut lists: Vec<Vec<i32>> = vec![line.split(" ").map(|num| num.parse::<i32>().unwrap()).collect()];

        while lists.last().unwrap().iter().filter(|i| i != &&0).count() > 0 {
            let current_list = lists.last().unwrap();
            let mut new_list: Vec<i32> = vec![];
            for i in 1..current_list.len() {
                new_list.push(current_list[i] - current_list[i - 1]);
            }

            lists.push(new_list);
        }

        lists.last_mut().unwrap().insert(0, 0);
        for i in (1..lists.len()).rev() {
            let new_val = lists[i-1].first().unwrap() - lists[i].first().unwrap();
            lists.get_mut(i-1).unwrap().insert(0, new_val);
        }

        result += lists[0].first().unwrap();
    }

    println!("Result: {result}");
}
