fn main() {
    let input = include_str!("../../input.txt");
    let mut results: Vec<i32> = Vec::new();

    for line in input
        .split("\n")
        .filter(|line| !line.is_empty()
    ) {
        let mut numbers: Vec<char> = Vec::new();
        for char in line.chars() {
            if char.is_numeric() {
                numbers.push(char);
            }
        }

        let num: i32 = format!("{}{}", numbers.first().unwrap(), numbers.last().unwrap())
            .parse()
            .unwrap();
        results.push(num);
    }

    println!("Result: {}", results.iter().sum::<i32>());
}
