fn main() {
    let input = include_str!("../../input.txt").trim_end();
    let mut result = 0;

    for line in input.lines() {
        let mut winning: Vec<i32> = Vec::new();
        let mut score: i32 = 0;

        let parts: Vec<&str> = line
            .split(": ")
            .last()
            .unwrap()
            .split("|")
            .collect();
            
        for num in parts.first().unwrap().split(" ") {
            if num.is_empty() { continue; }
            winning.push(num.parse::<i32>().unwrap());
        }

        for num in parts.last().unwrap().split(" ") {
            if num.is_empty() { continue; }
            if winning.contains(&num.parse::<i32>().unwrap()) {
                if score == 0 {
                    score = 1;
                } else {
                    score *= 2;
                }
            }
        }

        result += score;
    }

    println!("Result: {}", result);
}
